diff --git a/drivers/bus/pci/bsd/pci.c b/drivers/bus/pci/bsd/pci.c
index 39d65c6..a385947 100644
--- a/drivers/bus/pci/bsd/pci.c
+++ b/drivers/bus/pci/bsd/pci.c
@@ -324,7 +324,7 @@ pci_scan_one(int dev_pci_fd, struct pci_conf *conf)
 		int ret;
 
 		TAILQ_FOREACH(dev2, &rte_pci_bus.device_list, next) {
-			ret = pci_addr_cmp(&dev->addr, &dev2->addr);
+			ret = rte_pci_addr_cmp(&dev->addr, &dev2->addr);
 			if (ret > 0)
 				continue;
 			else if (ret < 0) {
diff --git a/drivers/bus/pci/linux/pci.c b/drivers/bus/pci/linux/pci.c
index e81969b..7367a82 100644
--- a/drivers/bus/pci/linux/pci.c
+++ b/drivers/bus/pci/linux/pci.c
@@ -366,7 +366,7 @@ pci_scan_one(const char *dirname, const struct rte_pci_addr *addr)
 		int ret;
 
 		TAILQ_FOREACH(dev2, &rte_pci_bus.device_list, next) {
-			ret = pci_addr_cmp(&dev->addr, &dev2->addr);
+			ret = rte_pci_addr_cmp(&dev->addr, &dev2->addr);
 			if (ret > 0)
 				continue;
 
diff --git a/drivers/bus/pci/linux/pci_vfio.c b/drivers/bus/pci/linux/pci_vfio.c
index 035ff50..543baa2 100644
--- a/drivers/bus/pci/linux/pci_vfio.c
+++ b/drivers/bus/pci/linux/pci_vfio.c
@@ -589,7 +589,7 @@ pci_vfio_map_resource_secondary(struct rte_pci_device *dev)
 
 	/* if we're in a secondary process, just find our tailq entry */
 	TAILQ_FOREACH(vfio_res, vfio_res_list, next) {
-		if (pci_addr_cmp(&vfio_res->pci_addr,
+		if (rte_pci_addr_cmp(&vfio_res->pci_addr,
 						 &dev->addr))
 			continue;
 		break;
diff --git a/drivers/bus/pci/pci_common.c b/drivers/bus/pci/pci_common.c
index 3e27779..8c17474 100644
--- a/drivers/bus/pci/pci_common.c
+++ b/drivers/bus/pci/pci_common.c
@@ -82,7 +82,7 @@ static struct rte_devargs *pci_devargs_lookup(struct rte_pci_device *dev)
 		if (devargs->bus != pbus)
 			continue;
 		devargs->bus->parse(devargs->name, &addr);
-		if (!pci_addr_cmp(&dev->addr, &addr))
+		if (!rte_pci_addr_cmp(&dev->addr, &addr))
 			return devargs;
 	}
 	return NULL;
@@ -309,7 +309,7 @@ rte_pci_probe_one(const struct rte_pci_addr *addr)
 		goto err_return;
 
 	FOREACH_DEVICE_ON_PCIBUS(dev) {
-		if (pci_addr_cmp(&dev->addr, addr))
+		if (rte_pci_addr_cmp(&dev->addr, addr))
 			continue;
 
 		ret = pci_probe_all_drivers(dev);
@@ -339,7 +339,7 @@ rte_pci_detach(const struct rte_pci_addr *addr)
 		return -1;
 
 	FOREACH_DEVICE_ON_PCIBUS(dev) {
-		if (pci_addr_cmp(&dev->addr, addr))
+		if (rte_pci_addr_cmp(&dev->addr, addr))
 			continue;
 
 		ret = rte_pci_detach_dev(dev);
@@ -441,7 +441,7 @@ pci_parse(const char *name, void *addr)
 	struct rte_pci_addr pci_addr;
 	bool parse;
 
-	parse = (pci_addr_parse(name, &pci_addr) == 0);
+	parse = (rte_pci_addr_parse(name, &pci_addr) == 0);
 	if (parse && addr != NULL)
 		*out = pci_addr;
 	return parse == false;
diff --git a/drivers/bus/pci/pci_common_uio.c b/drivers/bus/pci/pci_common_uio.c
index b58bcf5..0671131 100644
--- a/drivers/bus/pci/pci_common_uio.c
+++ b/drivers/bus/pci/pci_common_uio.c
@@ -63,7 +63,7 @@ pci_uio_map_secondary(struct rte_pci_device *dev)
 	TAILQ_FOREACH(uio_res, uio_res_list, next) {
 
 		/* skip this element if it doesn't match our PCI address */
-		if (pci_addr_cmp(&uio_res->pci_addr, &dev->addr))
+		if (rte_pci_addr_cmp(&uio_res->pci_addr, &dev->addr))
 			continue;
 
 		for (i = 0; i != uio_res->nb_maps; i++) {
@@ -189,7 +189,7 @@ pci_uio_find_resource(struct rte_pci_device *dev)
 	TAILQ_FOREACH(uio_res, uio_res_list, next) {
 
 		/* skip this element if it doesn't match our PCI address */
-		if (!pci_addr_cmp(&uio_res->pci_addr, &dev->addr))
+		if (!rte_pci_addr_cmp(&uio_res->pci_addr, &dev->addr))
 			return uio_res;
 	}
 	return NULL;
diff --git a/lib/librte_pci/rte_pci.c b/lib/librte_pci/rte_pci.c
index 1307a18..4351abc 100644
--- a/lib/librte_pci/rte_pci.c
+++ b/lib/librte_pci/rte_pci.c
@@ -127,13 +127,6 @@ eal_parse_pci_DomBDF(const char *input, struct rte_pci_addr *dev_addr)
 
 void
 rte_pci_device_name(const struct rte_pci_addr *addr,
-		    char *output, size_t size)
-{
-	pci_device_name(addr, output, size);
-}
-
-void
-pci_device_name(const struct rte_pci_addr *addr,
 		char *output, size_t size)
 {
 	RTE_VERIFY(size >= PCI_PRI_STR_SIZE);
@@ -146,11 +139,11 @@ int
 rte_eal_compare_pci_addr(const struct rte_pci_addr *addr,
 			 const struct rte_pci_addr *addr2)
 {
-	return pci_addr_cmp(addr, addr2);
+	return rte_pci_addr_cmp(addr, addr2);
 }
 
 int
-pci_addr_cmp(const struct rte_pci_addr *addr,
+rte_pci_addr_cmp(const struct rte_pci_addr *addr,
 	     const struct rte_pci_addr *addr2)
 {
 	uint64_t dev_addr, dev_addr2;
@@ -172,7 +165,7 @@ pci_addr_cmp(const struct rte_pci_addr *addr,
 }
 
 int
-pci_addr_parse(const char *str, struct rte_pci_addr *addr)
+rte_pci_addr_parse(const char *str, struct rte_pci_addr *addr)
 {
 	if (pci_bdf_parse(str, addr) == 0 ||
 	    pci_dbdf_parse(str, addr) == 0)
diff --git a/lib/librte_pci/rte_pci.h b/lib/librte_pci/rte_pci.h
index ea0897c..4f2cd18 100644
--- a/lib/librte_pci/rte_pci.h
+++ b/lib/librte_pci/rte_pci.h
@@ -166,7 +166,6 @@ int eal_parse_pci_BDF(const char *input, struct rte_pci_addr *dev_addr);
 int eal_parse_pci_DomBDF(const char *input, struct rte_pci_addr *dev_addr);
 
 /**
- * @deprecated
  * Utility function to write a pci device name, this device name can later be
  * used to retrieve the corresponding rte_pci_addr using eal_parse_pci_*
  * BDF helpers.
@@ -179,21 +178,6 @@ int eal_parse_pci_DomBDF(const char *input, struct rte_pci_addr *dev_addr);
  *	The output buffer size
  */
 void rte_pci_device_name(const struct rte_pci_addr *addr,
-			 char *output, size_t size);
-
-/**
- * Utility function to write a pci device name, this device name can later be
- * used to retrieve the corresponding rte_pci_addr using eal_parse_pci_*
- * BDF helpers.
- *
- * @param addr
- *	The PCI Bus-Device-Function address
- * @param output
- *	The output buffer string
- * @param size
- *	The output buffer size
- */
-void pci_device_name(const struct rte_pci_addr *addr,
 		     char *output, size_t size);
 
 /**
@@ -224,8 +208,8 @@ int rte_eal_compare_pci_addr(const struct rte_pci_addr *addr,
  *	Positive on addr is greater than addr2.
  *	Negative on addr is less than addr2, or error.
  */
-int pci_addr_cmp(const struct rte_pci_addr *addr,
-		 const struct rte_pci_addr *addr2);
+int rte_pci_addr_cmp(const struct rte_pci_addr *addr,
+		     const struct rte_pci_addr *addr2);
 
 
 /**
@@ -240,7 +224,7 @@ int pci_addr_cmp(const struct rte_pci_addr *addr,
  *	0 on success
  *	<0 otherwise
  */
-int pci_addr_parse(const char *str, struct rte_pci_addr *addr);
+int rte_pci_addr_parse(const char *str, struct rte_pci_addr *addr);
 
 /**
  * Map a particular resource from a file.
diff --git a/lib/librte_pci/rte_pci_version.map b/lib/librte_pci/rte_pci_version.map
index b5c9ec2..15d93d9 100644
--- a/lib/librte_pci/rte_pci_version.map
+++ b/lib/librte_pci/rte_pci_version.map
@@ -3,9 +3,9 @@ DPDK_17.11 {
 
 	eal_parse_pci_BDF;
 	eal_parse_pci_DomBDF;
-	pci_addr_cmp;
-	pci_addr_parse;
-	pci_device_name;
+	rte_pci_addr_cmp;
+	rte_pci_addr_parse;
+	rte_pci_device_name;
 	pci_map_resource;
 	pci_unmap_resource;
 	rte_eal_compare_pci_addr;